﻿package com.ipernity.api
{
	/* ============================================================================
	// IperAPILoader.as
	// Class that provides a dynamic implementation of the URLLoader to communicate with API
	// @version: 0.9
	// @release-date: 2008-10-10
	// @author: Franck Priola
	//
	// ---------------------------------------------------------------------------- */
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.URLVariables;
	import flash.net.URLRequestMethod;
	import flash.net.URLRequestHeader;
	import flash.events.Event;
	import flash.events.HTTPStatusEvent;
	import flash.events.SecurityErrorEvent;
	import flash.events.ErrorEvent;
	import flash.events.IOErrorEvent;
	import flash.events.EventDispatcher;
	
	
	
	public dynamic class IperAPILoader extends EventDispatcher
	{
		/** raw data response */
		private var _data:Object;
		
		/**
		 * make and send request
		 */
 		public function send()
		{
			/** variables to send */
			var URLvars:URLVariables = new URLVariables();
			for( var param:Object in this.params ) { URLvars[param] = this.params[param]; }
			
			/** url request to send */
			var URLreq:URLRequest = new URLRequest( this.url );
			URLreq.data = URLvars;
			URLreq.method = URLRequestMethod.POST;
			
			/** create the url loader instance */
			var loader:URLLoader = new URLLoader();
			
			/** add listeners */
			loader.addEventListener( Event.COMPLETE, _onComplete );
            loader.addEventListener( SecurityErrorEvent.SECURITY_ERROR, _onError );
            loader.addEventListener( IOErrorEvent.IO_ERROR, _onError );

			/** execute the request */
			loader.load( URLreq );
		}
		
		
		/**
		 * complete response handler
		 */
		private function _onComplete( e:Event ):void
		{
			if( !e.target.data )
			{
				_onError( new ErrorEvent(IOErrorEvent.IO_ERROR, false, false, "Bad response from remote server.") );
			}
			else
			{
				_data = e.target.data;
				dispatchEvent(e);
			}
		}
		
		
		/**
		 * error response handler
		 */
		private function _onError( e:* ):void
		{
			dispatchEvent(e);
		}

		
		/**
		 * read only data function
		 */
		public function get data():Object
		{
			return _data;
		}

	}
}
